/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.interfaces;

import org.eclipse.emf.ecore.EObject;

/**
 * Interface for constraint checker implementations.
 * 
 * @author hoelzlf
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: B26440F1029C58D8B881C889F3D87A95
 */
public interface IConstraintChecker {

	/**
	 * Determines whether the constraint checker is applicable to the given
	 * model element.
	 */
	boolean isApplicable(EObject modelElement);

	/** Applies the constraint checker to the given model element. */
	IConstraintViolation apply(EObject modelElement);
}
