/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.model.impl;

import org.eclipse.emf.ecore.util.EcoreUtil;
import org.fortiss.tooling.kernel.model.IRemovable;

/**
 * Static implementations for {@link IRemovable}.
 * 
 * @author hoelzl
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: 5B3BFFF46645CA9E7A150552528C27B9
 */
public final class IRemovableStaticImpl {

	/** Constructor. */
	private IRemovableStaticImpl() {
		// class not intended to be instantiated.
	}

	/** Returns true, if a parent exists. */
	public static boolean canRemove(IRemovable element) {
		return element.eContainer() != null;
	}

	/**
	 * Removes element from its parent container and deletes all references to
	 * it and its children.
	 */
	public static boolean remove(IRemovable element) {
		EcoreUtil.delete(element, true);
		return true;
	}
}
